diff --git a/scripts/gcc-plugins/size_overflow_plugin/e_fptrs.data b/scripts/gcc-plugins/size_overflow_plugin/e_fptrs.data
new file mode 100644
index 000000000000..ed95ec1cbf57
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_fptrs.data
@@ -0,0 +1,94 @@
+iov_iter_get_pages_alloc_fndecl_76_fptrs iov_iter_get_pages_alloc fndecl 0 76 NULL
+writebootimg_HYSDN_CARD_125_fptrs writebootimg HYSDN_CARD 0 125 NULL
+notifier_call_notifier_block_360_fptrs notifier_call notifier_block 0 360 NULL
+size_si_sm_handlers_648_fptrs size si_sm_handlers 0 648 NULL
+pte_hole_mm_walk_1233_fptrs pte_hole mm_walk 0 1233 NULL
+get_tdp_level_kvm_x86_ops_1250_fptrs get_tdp_level kvm_x86_ops 0 1250 NULL
+read_kernfs_ops_1325_fptrs read kernfs_ops 0 1325 NULL
+readlink_inode_operations_1540_fptrs readlink inode_operations 0 1540 NULL
+read_saa7146_use_ops_2236_fptrs read saa7146_use_ops 0 2236 NULL
+mdio_write_mdio_if_info_3033_fptrs mdio_write mdio_if_info 0 3033 NULL
+parse_header_ops_3963_fptrs parse header_ops 0 3963 NULL
+epp_write_data_parport_operations_4176_fptrs epp_write_data parport_operations 0 4176 NULL
+hugetlb_entry_mm_walk_5211_fptrs hugetlb_entry mm_walk 0 5211 NULL
+get_cr3_kvm_mmu_5347_fptrs get_cr3 kvm_mmu 0 5347 NULL
+add_endpoint_hc_driver_6482_fptrs add_endpoint hc_driver 0 6482 NULL
+f_read_cntrs_qib_devdata_6502_fptrs f_read_cntrs qib_devdata 0 6502 NULL
+drop_endpoint_hc_driver_6692_fptrs drop_endpoint hc_driver 0 6692 NULL
+command_hdac_bus_ops_7079_fptrs command hdac_bus_ops 0 7079 NULL
+privsize_nft_set_ops_7151_fptrs privsize nft_set_ops 0 7151 NULL
+add_frontend_dmx_demux_7322_fptrs add_frontend dmx_demux 0 7322 NULL
+get_power_state_size_pp_hwmgr_func_8417_fptrs get_power_state_size pp_hwmgr_func 0 8417 NULL
+map_sg_ib_dma_mapping_ops_9988_fptrs map_sg ib_dma_mapping_ops 0 9988 NULL
+run_apei_exec_ins_type_10886_fptrs run apei_exec_ins_type 0 10886 NULL
+find_vqs_virtio_config_ops_11797_fptrs find_vqs virtio_config_ops 0 11797 NULL
+pcibios_enable_irq_vardecl_11854_fptrs pcibios_enable_irq vardecl 0 11854 NULL
+read8_sync_rtl_io_12571_fptrs read8_sync rtl_io 0 12571 NULL
+transfer_drm_dp_aux_14204_fptrs transfer drm_dp_aux 0 14204 NULL
+dump_eeprom_eeprom_ops_15062_fptrs dump_eeprom eeprom_ops 0 15062 NULL
+mdio_read_mdio_if_info_15272_fptrs mdio_read mdio_if_info 0 15272 NULL
+get_pdptr_kvm_mmu_17247_fptrs get_pdptr kvm_mmu 0 17247 NULL
+read_hwrng_17766_fptrs read hwrng 0 17766 NULL
+count_objects_shrinker_18894_fptrs count_objects shrinker 0 18894 NULL
+proc_read_atmdev_ops_19414_fptrs proc_read atmdev_ops 0 19414 NULL
+get_response_hdac_bus_ops_19545_fptrs get_response hdac_bus_ops 0 19545 NULL
+dev_init_pre_alt_sd_19924_fptrs dev_init_pre_alt sd 0 19924 NULL
+translate_gpa_kvm_mmu_20350_fptrs translate_gpa kvm_mmu 0 20350 NULL
+waitpofready_HYSDN_CARD_20682_fptrs waitpofready HYSDN_CARD 0 20682 NULL
+data_read_hwrng_21861_fptrs data_read hwrng 0 21861 NULL
+pirq_enable_irq_fndecl_22603_fptrs pirq_enable_irq fndecl 0 22603 NULL
+bytes_number_item_operations_23452_fptrs bytes_number item_operations 0 23452 NULL
+crypto_init_drbg_state_ops_24657_fptrs crypto_init drbg_state_ops 0 24657 NULL
+transfer_snd_pcm_plugin_25081_fptrs transfer snd_pcm_plugin 0 25081 NULL
+ecp_write_data_parport_operations_26253_fptrs ecp_write_data parport_operations 0 26253 NULL
+raw_request_hid_ll_driver_26699_fptrs raw_request hid_ll_driver 0 26699 NULL
+get_xattr_handler_28917_fptrs get xattr_handler 0 28917 NULL
+read_b43_debugfs_fops_29607_fptrs read b43_debugfs_fops 0 29607 NULL
+verify_planes_array_vb2_buf_ops_30329_fptrs verify_planes_array vb2_buf_ops 0 30329 NULL
+pmd_entry_mm_walk_30448_fptrs pmd_entry mm_walk 0 30448 NULL
+ecp_read_data_parport_operations_31283_fptrs ecp_read_data parport_operations 0 31283 NULL
+write_tty_ldisc_ops_32094_fptrs write tty_ldisc_ops 0 32094 NULL
+read32_tpm_tis_phy_ops_33980_fptrs read32 tpm_tis_phy_ops 0 33980 NULL
+client_channels_snd_pcm_plugin_36324_fptrs client_channels snd_pcm_plugin 0 36324 NULL
+filter_get_rx_ids_efx_nic_type_37093_fptrs filter_get_rx_ids efx_nic_type 0 37093 NULL
+gva_to_gpa_kvm_mmu_37200_fptrs gva_to_gpa kvm_mmu 0 37200 NULL
+exec_verb_hdac_device_37803_fptrs exec_verb hdac_device 0 37803 NULL
+get_key_fscache_cookie_def_39056_fptrs get_key fscache_cookie_def 0 39056 NULL
+uni2char_nls_table_41293_fptrs uni2char nls_table 0 41293 NULL
+get_sset_count_phy_driver_42200_fptrs get_sset_count phy_driver 0 42200 NULL
+rdma_get_min_cnq_msix_qed_rdma_ops_42444_fptrs rdma_get_min_cnq_msix qed_rdma_ops 0 42444 NULL
+read_b43legacy_debugfs_fops_42452_fptrs read b43legacy_debugfs_fops 0 42452 NULL
+ndo_init_net_device_ops_42812_fptrs ndo_init net_device_ops 0 42812 NULL
+get_sset_count_ethtool_ops_43861_fptrs get_sset_count ethtool_ops 0 43861 NULL
+epp_read_data_parport_operations_44383_fptrs epp_read_data parport_operations 0 44383 NULL
+preproc_res_proc_context_45654_fptrs preproc res_proc_context 0 45654 NULL
+max_channels_evtchn_ops_45841_fptrs max_channels evtchn_ops 0 45841 NULL
+parport_ieee1284_epp_read_addr_fndecl_48478_fptrs parport_ieee1284_epp_read_addr fndecl 0 48478 NULL nohasharray
+parport_ieee1284_ecp_read_data_fndecl_48478_fptrs parport_ieee1284_ecp_read_data fndecl 0 48478 &parport_ieee1284_epp_read_addr_fndecl_48478_fptrs nohasharray
+parport_ieee1284_epp_read_data_fndecl_48478_fptrs parport_ieee1284_epp_read_data fndecl 0 48478 &parport_ieee1284_ecp_read_data_fndecl_48478_fptrs
+get_eld_i915_audio_component_ops_48948_fptrs get_eld i915_audio_component_ops 0 48948 NULL
+listxattr_inode_operations_50507_fptrs listxattr inode_operations 0 50507 NULL
+pte_entry_mm_walk_51234_fptrs pte_entry mm_walk 0 51234 NULL
+probe_parport_driver_51942_fptrs probe parport_driver 0 51942 NULL
+parport_ieee1284_ecp_write_addr_fndecl_52806_fptrs parport_ieee1284_ecp_write_addr fndecl 0 52806 NULL nohasharray
+parport_ieee1284_epp_write_addr_fndecl_52806_fptrs parport_ieee1284_epp_write_addr fndecl 0 52806 &parport_ieee1284_ecp_write_addr_fndecl_52806_fptrs nohasharray
+parport_ieee1284_ecp_write_data_fndecl_52806_fptrs parport_ieee1284_ecp_write_data fndecl 0 52806 &parport_ieee1284_epp_write_addr_fndecl_52806_fptrs nohasharray
+parport_ieee1284_epp_write_data_fndecl_52806_fptrs parport_ieee1284_epp_write_data fndecl 0 52806 &parport_ieee1284_ecp_write_data_fndecl_52806_fptrs
+ide_inb_fndecl_54462_fptrs ide_inb fndecl 0 54462 NULL nohasharray
+ide_mm_inb_fndecl_54462_fptrs ide_mm_inb fndecl 0 54462 &ide_inb_fndecl_54462_fptrs
+nr_cached_objects_super_operations_54808_fptrs nr_cached_objects super_operations 0 54808 NULL
+connect_frontend_dmx_demux_55378_fptrs connect_frontend dmx_demux 0 55378 NULL
+max_size_akcipher_alg_57009_fptrs max_size akcipher_alg 0 57009 NULL
+byte_read_data_parport_operations_57730_fptrs byte_read_data parport_operations 0 57730 NULL
+init_pci_serial_quirk_57875_fptrs init pci_serial_quirk 0 57875 NULL
+get_num_of_pp_table_entries_pp_hwmgr_func_58341_fptrs get_num_of_pp_table_entries pp_hwmgr_func 0 58341 NULL
+writebootseq_HYSDN_CARD_59000_fptrs writebootseq HYSDN_CARD 0 59000 NULL
+mw_count_ntb_dev_ops_59352_fptrs mw_count ntb_dev_ops 0 59352 NULL
+nibble_read_data_parport_operations_60589_fptrs nibble_read_data parport_operations 0 60589 NULL
+f_read_portcntrs_qib_devdata_61868_fptrs f_read_portcntrs qib_devdata 0 61868 NULL
+filter_count_rx_used_efx_nic_type_62026_fptrs filter_count_rx_used efx_nic_type 0 62026 NULL
+check_bandwidth_hc_driver_63438_fptrs check_bandwidth hc_driver 0 63438 NULL
+spad_count_ntb_dev_ops_63660_fptrs spad_count ntb_dev_ops 0 63660 NULL
+compat_write_data_parport_operations_64123_fptrs compat_write_data parport_operations 0 64123 NULL
+test_walk_mm_walk_64132_fptrs test_walk mm_walk 0 64132 NULL
+get_regs_len_ethtool_ops_65213_fptrs get_regs_len ethtool_ops 0 65213 NULL
diff --git a/scripts/gcc-plugins/size_overflow_plugin/e_vars.data b/scripts/gcc-plugins/size_overflow_plugin/e_vars.data
new file mode 100644
index 000000000000..8f86ad7350a4
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/e_vars.data
@@ -0,0 +1,140 @@
+max_num_of_queues_per_device_vardecl_1365_vars max_num_of_queues_per_device vardecl 0 1365 NULL
+dev_number_vardecl_rio_mport_cdev_c_1836_vars dev_number vardecl_rio_mport_cdev.c 0 1836 NULL
+sdebug_num_tgts_vardecl_scsi_debug_c_2223_vars sdebug_num_tgts vardecl_scsi_debug.c 0 2223 NULL
+big_oops_buf_sz_vardecl_platform_c_2265_vars big_oops_buf_sz vardecl_platform.c 0 2265 NULL
+gpio_devt_vardecl_gpiolib_c_2478_vars gpio_devt vardecl_gpiolib.c 0 2478 NULL
+tx_max_out_p_vardecl_mptlan_c_2906_vars tx_max_out_p vardecl_mptlan.c 0 2906 NULL
+ecryptfs_message_buf_len_vardecl_3736_vars ecryptfs_message_buf_len vardecl 0 3736 NULL
+max_sg_segs_vardecl_osst_c_4365_vars max_sg_segs vardecl_osst.c 0 4365 NULL
+dma_tx_num_vardecl_altera_tse_main_c_4981_vars dma_tx_num vardecl_altera_tse_main.c 0 4981 NULL
+mlx4_log_num_mgm_entry_size_vardecl_5042_vars mlx4_log_num_mgm_entry_size vardecl 0 5042 NULL
+ring_buffer_size_vardecl_ldusb_c_5645_vars ring_buffer_size vardecl_ldusb.c 0 5645 NULL
+count_vardecl_speedtest_c_6069_vars count vardecl_speedtest.c 0 6069 NULL
+sysctl_perf_event_max_stack_vardecl_7792_vars sysctl_perf_event_max_stack vardecl 0 7792 NULL
+goldfish_tty_line_count_vardecl_goldfish_c_8058_vars goldfish_tty_line_count vardecl_goldfish.c 0 8058 NULL
+rx_buf_sz_vardecl_r8169_c_9136_vars rx_buf_sz vardecl_r8169.c 0 9136 NULL
+_max_socket_vardecl_x2apic_uv_x_c_9456_vars _max_socket vardecl_x2apic_uv_x.c 0 9456 NULL
+kdb_max_commands_vardecl_kdb_main_c_9529_vars kdb_max_commands vardecl_kdb_main.c 0 9529 NULL
+legacy_count_vardecl_pty_c_9908_vars legacy_count vardecl_pty.c 0 9908 NULL
+max_ptlrpcds_vardecl_ptlrpcd_c_9939_vars max_ptlrpcds vardecl_ptlrpcd.c 0 9939 NULL
+read_buffer_size_vardecl_legousbtower_c_10184_vars read_buffer_size vardecl_legousbtower.c 0 10184 NULL
+iio_devt_vardecl_industrialio_core_c_10237_vars iio_devt vardecl_industrialio-core.c 0 10237 NULL
+dma_rx_num_vardecl_altera_tse_main_c_10728_vars dma_rx_num vardecl_altera_tse_main.c 0 10728 NULL
+default_rds_buf_vardecl_fmdrv_common_c_11072_vars default_rds_buf vardecl_fmdrv_common.c 0 11072 NULL
+snd_efw_resp_buf_size_vardecl_11291_vars snd_efw_resp_buf_size vardecl 0 11291 NULL
+_max_pnode_vardecl_x2apic_uv_x_c_11492_vars _max_pnode vardecl_x2apic_uv_x.c 0 11492 NULL
+slave_num_vardecl_shdma_base_c_11603_vars slave_num vardecl_shdma-base.c 0 11603 NULL
+c4iw_wr_log_size_order_vardecl_device_c_13134_vars c4iw_wr_log_size_order vardecl_device.c 0 13134 NULL
+vhci_num_controllers_vardecl_13178_vars vhci_num_controllers vardecl 0 13178 NULL
+max_sets_vardecl_ip_set_core_c_13393_vars max_sets vardecl_ip_set_core.c 0 13393 NULL
+sysctl_perf_event_max_contexts_per_stack_vardecl_13620_vars sysctl_perf_event_max_contexts_per_stack vardecl 0 13620 NULL
+buffer_pos_vardecl_event_buffer_c_13658_vars buffer_pos vardecl_event_buffer.c 0 13658 NULL
+ipr_max_devs_vardecl_ipr_c_13921_vars ipr_max_devs vardecl_ipr.c 0 13921 NULL
+pasid_limit_vardecl_kfd_pasid_c_14334_vars pasid_limit vardecl_kfd_pasid.c 0 14334 NULL
+sel_end_vardecl_selection_c_14469_vars sel_end vardecl_selection.c 0 14469 NULL
+osst_max_sg_segs_vardecl_osst_c_14954_vars osst_max_sg_segs vardecl_osst.c 0 14954 NULL
+n_barrier_cbs_vardecl_rcutorture_c_16575_vars n_barrier_cbs vardecl_rcutorture.c 0 16575 NULL
+csio_fcoe_rnodes_vardecl_16778_vars csio_fcoe_rnodes vardecl 0 16778 NULL
+cmdlog_vardecl_ipw2200_c_18024_vars cmdlog vardecl_ipw2200.c 0 18024 NULL
+nreaders_vardecl_rcutorture_c_18862_vars nreaders vardecl_rcutorture.c 0 18862 NULL
+num_freq_table_entries_vardecl_sfi_cpufreq_c_18898_vars num_freq_table_entries vardecl_sfi-cpufreq.c 0 18898 NULL
+ndoms_cur_vardecl_core_c_19519_vars ndoms_cur vardecl_core.c 0 19519 NULL
+nwriters_vardecl_rcuperf_c_20234_vars nwriters vardecl_rcuperf.c 0 20234 NULL
+mpegbufs_vardecl_cx231xx_417_c_20303_vars mpegbufs vardecl_cx231xx-417.c 0 20303 NULL
+major_vardecl_dm_c_21185_vars major vardecl_dm.c 0 21185 NULL
+acpi_current_gpe_count_vardecl_21469_vars acpi_current_gpe_count vardecl 0 21469 NULL
+max_nr_vardecl_exynos_combiner_c_21761_vars max_nr vardecl_exynos-combiner.c 0 21761 NULL
+xprt_max_tcp_slot_table_entries_vardecl_xprtsock_c_21949_vars xprt_max_tcp_slot_table_entries vardecl_xprtsock.c 0 21949 NULL
+ch_count_vardecl_ib_srp_c_22190_vars ch_count vardecl_ib_srp.c 0 22190 NULL
+nreaders_stress_vardecl_locktorture_c_22217_vars nreaders_stress vardecl_locktorture.c 0 22217 NULL
+_major_vardecl_dm_c_23233_vars _major vardecl_dm.c 0 23233 NULL
+nreaders_vardecl_rcuperf_c_23383_vars nreaders vardecl_rcuperf.c 0 23383 NULL
+input_buffer_size_vardecl_seq_midi_c_23961_vars input_buffer_size vardecl_seq_midi.c 0 23961 NULL
+st_max_sg_segs_vardecl_st_c_24474_vars st_max_sg_segs vardecl_st.c 0 24474 NULL
+accent_table_size_vardecl_24972_vars accent_table_size vardecl 0 24972 NULL
+grefs_per_grant_frame_vardecl_grant_table_c_25386_vars grefs_per_grant_frame vardecl_grant-table.c 0 25386 NULL
+num_prealloc_crypto_pages_vardecl_crypto_c_25796_vars num_prealloc_crypto_pages vardecl_crypto.c 0 25796 NULL
+num_sg_lists_vardecl_25860_vars num_sg_lists vardecl 0 25860 NULL
+core_name_size_vardecl_coredump_c_26013_vars core_name_size vardecl_coredump.c 0 26013 NULL
+total_cpus_vardecl_27560_vars total_cpus vardecl 0 27560 NULL
+nfakewriters_vardecl_rcutorture_c_30320_vars nfakewriters vardecl_rcutorture.c 0 30320 NULL
+DAC960_ControllerCount_vardecl_DAC960_c_31089_vars DAC960_ControllerCount vardecl_DAC960.c 0 31089 NULL
+first_slot_vardecl_cpcihp_generic_c_32129_vars first_slot vardecl_cpcihp_generic.c 0 32129 NULL
+prof_shift_vardecl_profile_c_32143_vars prof_shift vardecl_profile.c 0 32143 NULL
+num_rcv_urbs_vardecl_usbatm_c_32830_vars num_rcv_urbs vardecl_usbatm.c 0 32830 NULL
+_min_socket_vardecl_x2apic_uv_x_c_33176_vars _min_socket vardecl_x2apic_uv_x.c 0 33176 NULL
+num_ae_requests_vardecl_33594_vars num_ae_requests vardecl 0 33594 NULL
+blkdev_minors_vardecl_dev_c_34365_vars blkdev_minors vardecl_dev.c 0 34365 NULL
+cpu_npartitions_vardecl_linux_cpu_c_34622_vars cpu_npartitions vardecl_linux-cpu.c 0 34622 NULL
+at_max_vardecl_35692_vars at_max vardecl 0 35692 NULL
+nwriters_stress_vardecl_locktorture_c_36080_vars nwriters_stress vardecl_locktorture.c 0 36080 NULL
+max_sg_segs_vardecl_st_c_36551_vars max_sg_segs vardecl_st.c 0 36551 NULL
+null_major_vardecl_null_blk_c_36718_vars null_major vardecl_null_blk.c 0 36718 NULL
+bufsiz_vardecl_spidev_c_36763_vars bufsiz vardecl_spidev.c 0 36763 NULL
+netdev_flow_limit_table_len_vardecl_36765_vars netdev_flow_limit_table_len vardecl 0 36765 NULL
+uwb_est_size_vardecl_est_c_36881_vars uwb_est_size vardecl_est.c 0 36881 NULL
+rtc_devt_vardecl_rtc_dev_c_37090_vars rtc_devt vardecl_rtc-dev.c 0 37090 NULL
+ncpus_vardecl_aoecmd_c_37517_vars ncpus vardecl_aoecmd.c 0 37517 NULL
+fb_bpp_vardecl_udl_fb_c_38075_vars fb_bpp vardecl_udl_fb.c 0 38075 NULL
+pipe_max_size_vardecl_38097_vars pipe_max_size vardecl 0 38097 NULL
+tcp_metrics_hash_log_vardecl_tcp_metrics_c_38657_vars tcp_metrics_hash_log vardecl_tcp_metrics.c 0 38657 NULL
+max_num_clients_vardecl_ntb_transport_c_38745_vars max_num_clients vardecl_ntb_transport.c 0 38745 NULL
+sg_buffers_vardecl_dmatest_c_38796_vars sg_buffers vardecl_dmatest.c 0 38796 NULL
+sel_start_vardecl_selection_c_39245_vars sel_start vardecl_selection.c 0 39245 NULL
+hash_table_size_vardecl_39253_vars hash_table_size vardecl 0 39253 NULL
+pktdev_major_vardecl_pktcdvd_c_39506_vars pktdev_major vardecl_pktcdvd.c 0 39506 NULL
+defcmd_set_count_vardecl_kdb_main_c_39817_vars defcmd_set_count vardecl_kdb_main.c 0 39817 NULL
+allocation_floor_vardecl_dell_rbu_c_40106_vars allocation_floor vardecl_dell_rbu.c 0 40106 NULL
+memcg_nr_cache_ids_vardecl_40280_vars memcg_nr_cache_ids vardecl 0 40280 NULL
+rose_ndevs_vardecl_af_rose_c_40602_vars rose_ndevs vardecl_af_rose.c 0 40602 NULL
+xprt_tcp_slot_table_entries_vardecl_xprtsock_c_40779_vars xprt_tcp_slot_table_entries vardecl_xprtsock.c 0 40779 NULL
+major_nr_vardecl_umem_c_41471_vars major_nr vardecl_umem.c 0 41471 NULL
+pcpu_unit_pages_vardecl_percpu_c_41525_vars pcpu_unit_pages vardecl_percpu.c 0 41525 NULL
+nr_online_nodes_vardecl_41549_vars nr_online_nodes vardecl 0 41549 NULL
+prof_len_vardecl_profile_c_42405_vars prof_len vardecl_profile.c 0 42405 NULL
+mtu_max_vardecl_42563_vars mtu_max vardecl 0 42563 NULL
+phonet_rxq_size_vardecl_f_phonet_c_43017_vars phonet_rxq_size vardecl_f_phonet.c 0 43017 NULL
+output_buffer_size_vardecl_seq_midi_c_43084_vars output_buffer_size vardecl_seq_midi.c 0 43084 NULL
+rds_buf_vardecl_radio_si470x_usb_c_43439_vars rds_buf vardecl_radio-si470x-usb.c 0 43439 NULL
+xpc_nasid_mask_nbytes_vardecl_xpc_partition_c_45405_vars xpc_nasid_mask_nbytes vardecl_xpc_partition.c 0 45405 NULL
+num_fault_mutexes_vardecl_hugetlb_c_45857_vars num_fault_mutexes vardecl_hugetlb.c 0 45857 NULL
+qxl_num_crtc_vardecl_46583_vars qxl_num_crtc vardecl 0 46583 NULL
+fw_cdev_major_vardecl_46618_vars fw_cdev_major vardecl 0 46618 NULL
+mc_groups_longs_vardecl_genetlink_c_46774_vars mc_groups_longs vardecl_genetlink.c 0 46774 NULL
+cy_next_channel_vardecl_cyclades_c_46964_vars cy_next_channel vardecl_cyclades.c 0 46964 NULL
+rds_buf_vardecl_radio_si470x_i2c_c_48053_vars rds_buf vardecl_radio-si470x-i2c.c 0 48053 NULL
+osst_max_dev_vardecl_osst_c_48086_vars osst_max_dev vardecl_osst.c 0 48086 NULL
+ramoops_console_size_vardecl_ram_c_48215_vars ramoops_console_size vardecl_ram.c 0 48215 NULL
+da_num_tokens_vardecl_dell_smbios_c_48798_vars da_num_tokens vardecl_dell-smbios.c 0 48798 NULL
+num_requests_vardecl_48964_vars num_requests vardecl 0 48964 NULL
+nr_ndevs_vardecl_af_netrom_c_49435_vars nr_ndevs vardecl_af_netrom.c 0 49435 NULL
+amdgpu_sched_hw_submission_vardecl_50202_vars amdgpu_sched_hw_submission vardecl 0 50202 NULL
+agg_wsize_vardecl_50735_vars agg_wsize vardecl 0 50735 NULL
+num_var_ranges_vardecl_51769_vars num_var_ranges vardecl 0 51769 NULL
+num_snd_urbs_vardecl_usbatm_c_52685_vars num_snd_urbs vardecl_usbatm.c 0 52685 NULL
+tpm_devt_vardecl_53182_vars tpm_devt vardecl 0 53182 NULL
+xpc_nasid_mask_nlongs_vardecl_53252_vars xpc_nasid_mask_nlongs vardecl 0 53252 NULL
+max_dev_vardecl_osst_c_53523_vars max_dev vardecl_osst.c 0 53523 NULL
+dma_txqueue_sz_vardecl_tsi721_dma_c_53597_vars dma_txqueue_sz vardecl_tsi721_dma.c 0 53597 NULL
+ramoops_pmsg_size_vardecl_ram_c_53601_vars ramoops_pmsg_size vardecl_ram.c 0 53601 NULL
+xprt_udp_slot_table_entries_vardecl_xprtsock_c_56096_vars xprt_udp_slot_table_entries vardecl_xprtsock.c 0 56096 NULL
+test_buf_size_vardecl_dmatest_c_56686_vars test_buf_size vardecl_dmatest.c 0 56686 NULL
+part_shift_vardecl_loop_c_57103_vars part_shift vardecl_loop.c 0 57103 NULL
+nr_cpu_ids_vardecl_57399_vars nr_cpu_ids vardecl 0 57399 NULL
+mdp_major_vardecl_57774_vars mdp_major vardecl 0 57774 NULL
+acpi_gbl_integer_byte_width_vardecl_58054_vars acpi_gbl_integer_byte_width vardecl 0 58054 NULL
+window_vardecl_tcp_cdg_c_58396_vars window vardecl_tcp_cdg.c 0 58396 NULL
+bufsize_vardecl_tcp_probe_c_58414_vars bufsize vardecl_tcp_probe.c 0 58414 NULL
+ebcnt_vardecl_torturetest_c_58475_vars ebcnt vardecl_torturetest.c 0 58475 NULL
+ramoops_ftrace_size_vardecl_ram_c_58686_vars ramoops_ftrace_size vardecl_ram.c 0 58686 NULL
+pcpu_nr_units_vardecl_percpu_c_59323_vars pcpu_nr_units vardecl_percpu.c 0 59323 NULL
+queue_length_vardecl_ua101_c_59524_vars queue_length vardecl_ua101.c 0 59524 NULL
+perdev_minors_vardecl_block_c_60809_vars perdev_minors vardecl_block.c 0 60809 NULL
+fbcon_softback_size_vardecl_fbcon_c_61184_vars fbcon_softback_size vardecl_fbcon.c 0 61184 NULL
+_min_pnode_vardecl_x2apic_uv_x_c_63577_vars _min_pnode vardecl_x2apic_uv_x.c 0 63577 NULL
+nbds_max_vardecl_nbd_c_63801_vars nbds_max vardecl_nbd.c 0 63801 NULL
+__max_logical_packages_vardecl_64002_vars __max_logical_packages vardecl 0 64002 NULL
+ubiblock_major_vardecl_block_c_64105_vars ubiblock_major vardecl_block.c 0 64105 NULL
+dev_number_vardecl_rio_cm_c_64286_vars dev_number vardecl_rio_cm.c 0 64286 NULL
+wear_eb_count_vardecl_nandsim_c_65291_vars wear_eb_count vardecl_nandsim.c 0 65291 NULL
+fpu_user_xstate_size_vardecl_65370_vars fpu_user_xstate_size vardecl 0 65370 NULL
diff --git a/scripts/gcc-plugins/size_overflow_plugin/generate_size_overflow_hash.sh b/scripts/gcc-plugins/size_overflow_plugin/generate_size_overflow_hash.sh
new file mode 100644
index 000000000000..be9724d8e2c9
--- /dev/null
+++ b/scripts/gcc-plugins/size_overflow_plugin/generate_size_overflow_hash.sh
@@ -0,0 +1,103 @@
+#!/bin/bash
+
+# This script generates the hash table (size_overflow_hash.h) for the size_overflow gcc plugin (size_overflow_plugin.c).
+
+header1="size_overflow_hash.h"
+database="size_overflow_hash.data"
+n=65536
+hashtable_name="size_overflow_hash"
+
+usage() {
+cat <<EOF
+usage: $0 options
+OPTIONS:
+        -h|--help               help
+	-o			header file
+	-d			database file
+	-n			hash array size
+	-s			name of the hash table
+EOF
+    return 0
+}
+
+while true
+do
+    case "$1" in
+    -h|--help)	usage && exit 0;;
+    -n)		n=$2; shift 2;;
+    -o)		header1="$2"; shift 2;;
+    -d)		database="$2"; shift 2;;
+    -s)		hashtable_name="$2"; shift 2;;
+    --)		shift 1; break ;;
+     *)		break ;;
+    esac
+done
+
+create_defines() {
+	for i in `seq 0 31`
+	do
+		echo -e "#define PARAM"$i" (1U << "$i")" >> "$header1"
+	done
+	echo >> "$header1"
+}
+
+create_structs() {
+	rm -f "$header1"
+
+	create_defines
+
+	cat "$database" | while read data
+	do
+		data_array=($data)
+		struct_hash_name="${data_array[0]}"
+		funcn="${data_array[1]}"
+		context="${data_array[2]}"
+		params="${data_array[3]}"
+		next="${data_array[5]}"
+
+		echo "const struct size_overflow_hash $struct_hash_name = {" >> "$header1"
+
+		echo -e "\t.next\t= $next,\n\t.name\t= \"$funcn\",\n\t.context\t= \"$context\"," >> "$header1"
+		echo -en "\t.param\t= " >> "$header1"
+		line=
+		for param_num in ${params//-/ };
+		do
+			line="${line}PARAM"$param_num"|"
+		done
+
+		echo -e "${line%?},\n};\n" >> "$header1"
+	done
+}
+
+create_headers() {
+	echo "const struct size_overflow_hash * const $hashtable_name[$n] = {" >> "$header1"
+}
+
+create_array_elements() {
+	index=0
+	grep -v "nohasharray" $database | sort -n -k 5 | while read data
+	do
+		data_array=($data)
+		i="${data_array[4]}"
+		hash="${data_array[0]}"
+		while [[ $index -lt $i ]]
+		do
+			echo -e "\t["$index"]\t= NULL," >> "$header1"
+			index=$(($index + 1))
+		done
+		index=$(($index + 1))
+		echo -e "\t["$i"]\t= &"$hash"," >> "$header1"
+	done
+	echo '};' >> $header1
+}
+
+size_overflow_plugin_dir=`dirname $header1`
+if [ "$size_overflow_plugin_dir" != '.' ]; then
+	mkdir -p "$size_overflow_plugin_dir" 2> /dev/null
+fi
+
+create_structs
+create_headers
+create_array_elements
+
+exit 0
